/*
 
 Copyright (C) 2006            Jacek Piszczek (fuhQuakeLauncher)
 
 This program is free software; you can redistribute it and/or
 modify it under the terms of the GNU General Public License
 as published by the Free Software Foundation; either version 2
 of the License, or (at your option) any later version.
 
 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  
 
 See the included (GNU.txt) GNU General Public License for more details.
 
 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

*/

#include <unistd.h>
#import "myController.h"

@implementation myController

- (IBAction)selectbasedir:(id)sender
{
    chdir([[[NSBundle mainBundle] bundlePath] UTF8String]);

    NSOpenPanel *panel = [NSOpenPanel openPanel];
    NSString *cpath = [[basedir stringValue] stringByStandardizingPath];
    
    if ((cpath == nil) || [cpath length] < 1) 
    {
        cpath = [NSString stringWithUTF8String:"../basedir"];
    }
    
    if (![cpath isAbsolutePath])
    {
        // we need an abs path here, damnit
        char buffer[4096];
        
        getcwd(buffer,4096);
        
        NSString *cwd = [NSString stringWithUTF8String:buffer];
        cwd = [cwd stringByAppendingPathComponent:cpath];
        
        cpath = [cwd stringByStandardizingPath];
    }
    
    NSString *parent = [cpath stringByDeletingLastPathComponent];
    NSString *directory = [cpath lastPathComponent];

    [panel setCanChooseFiles:NO];
    [panel setCanChooseDirectories:YES];

    if ([panel runModalForDirectory:parent file:directory types:nil])
    {
        NSArray *dirarray = [panel filenames];
        NSString *dir = [dirarray objectAtIndex:0];
        
        if (dir != nil)
        {
            // wtf don't the fucking cocoa bindings work properly here??
            // can somebody fucking tell me wtf isn't this change saved??
            // argh!
            [basedir setStringValue:dir];
        }
    }
}

#define MAX_ARGS 64

- (IBAction)start:(id)sender
{
    char basedir_path[4096] = "../basedir";
    char config_file[128] = "config";
    char params_string[512] = "";
    char *paramsstr = params_string;
    void *argv[64 + 3];
    int lastarg = 0;

    char *bdir_user = (char*)[[basedir stringValue] UTF8String];
    char *config_user = (char*)[[config stringValue] UTF8String];
    char *width_user = (char*)[[width stringValue] UTF8String];
    char *height_user = (char*)[[height stringValue] UTF8String];
    char *depth_user = 0;
    char *params_user = (char*)[[params stringValue] UTF8String];
    
    switch ([depth indexOfSelectedItem])
    {
        case 0: depth_user = "15"; break;
        case 1: depth_user = "16"; break;
        case 2: default: depth_user = "24"; break;
    }

    if ((bdir_user != nil) && bdir_user[0])
    {
        strlcpy(basedir_path,bdir_user,4096);
    }

    if ((config_user != nil) && config_user[0])
    {
        strlcpy(config_file,config_user,128);
    }

    if ((params_user != nil) && params_user[0])
    {
        // leave 1 byte free, plz
        strlcpy(params_string,params_user,511);
    }

    // build std args
    argv[lastarg++] = "./Contents/Resources/fuhQuake.gl";

    argv[lastarg++] = "-basedir";
    argv[lastarg++] = basedir_path;
    argv[lastarg++] = "+cfg_load";
    argv[lastarg++] = config_file;

    if ((width_user != 0) && (height_user != 0) && (width_user[0]))
    {
        argv[lastarg++] = "-width";
        argv[lastarg++] = width_user;
        
        argv[lastarg++] = "-height";
        argv[lastarg++] = height_user;
    }
    
    if ((depth_user != 0) && (depth_user[0]))
    {
        argv[lastarg++] = "-depth";
        argv[lastarg++] = depth_user;
    }

    // look for additional arguments
    int plength = 0;
    
    // lame params string analyzer :)
    // doesn't handle "" cause I'm too lazy. add it if you need it :)
    do
    {
        paramsstr++;
        plength++;
        
        if ((*paramsstr == ' ') || (*paramsstr == 0))
        {
            *paramsstr = 0;
            argv[lastarg++] = paramsstr - plength;
            plength = 0;
            paramsstr++;
        }
        
        if (lastarg > MAX_ARGS) break;
    } while (*paramsstr);

    // terminate args
    argv[lastarg] = nil;

    // make sure we're in a proper current dir
    chdir([[[NSBundle mainBundle] bundlePath] UTF8String]);

    // fork and launch
    if (fork() == 0)
    {
        char buffer[256];
        getcwd(buffer,256);

        execvp("./Contents/Resources/fuhQuake.gl",(char**)argv);

        exit(0);
    }
}

@end
